
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java-设计模式-观察者模式 / iVAN</title>

    <meta name="description" content="java-设计模式-观察者模式 简单观察者模式 观察者模式中,一个被观察者管理所有依赖它的观察者,并且在本身的状态改变时主动发出通知.这通常通过呼叫各观察者所提供的方法来实现.此种模式通常被用来实现事件处理系统. 角色 抽象被观察者角色:把所有对观察者对象的引用保存在一个集合中,每个被观察者角色都可以有任意数量的观察者.被观察者提供一个接口,可以增加和删除观察者角色.一般用一个抽象类和接口来实现. 抽象观察者角色:为所有具体的观察者定义一个接口,在得到主题的通知时更新自己. 具体被观察者角色:在被观察者内部状态改变时,给所有登">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">java-设计模式-观察者模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>简单观察者模式</h2>
<p>观察者模式中，一个被观察者管理所有依赖它的观察者，并且在本身的状态改变时主动发出通知。这通常通过呼叫各观察者所提供的方法来实现。此种模式通常被用来实现事件处理系统。 <br />
角色 <br /><strong>抽象被观察者角色</strong>：把所有对观察者对象的引用保存在一个集合中，每个被观察者角色都可以有任意数量的观察者。被观察者提供一个接口，可以增加和删除观察者角色。一般用一个抽象类和接口来实现。 <br /><strong>抽象观察者角色</strong>：为所有具体的观察者定义一个接口，在得到主题的通知时更新自己。 <br /><strong>具体被观察者角色</strong>：在被观察者内部状态改变时，给所有登记过的观察者发出通知。具体被观察者角色通常用一个子类实现。 <br /><strong>具体观察者角色</strong>：该角色实现抽象观察者角色所要求的更新接口，以便使本身的状态与主题的状态相协调。通常用一个子类实现。如果需要，具体观察者角色可以保存一个指向具体主题角色的引用。 <br />
适用场景 <br />
1) 当一个抽象模型有两个方面, 其中一个方面依赖于另一方面。将这二者封装在独立的对象中以使它们可以各自独立地改变和复用。 <br />
2) 当对一个对象的改变需要同时改变其它对象, 而不知道具体有多少对象有待改变。 <br />
3) 当一个对象必须通知其它对象，而它又不能假定其它对象是谁。换言之, 你不希望这些对象是紧密耦合的</p>
<pre><code>public interface Watcher
{
     public void update();
}  </code></pre>
<pre><code>public interface Watched
{
     public void addWatcher(Watcher watcher);  

     public void removeWatcher(Watcher watcher);  

     public void notifyWatchers();
}  </code></pre>
<pre><code>public class Thief implements Watcher
{
     @Override
     public void update()
     {
          System.out.println(“运输车有行动，强盗准备动手");
     }
}  </code></pre>
<pre><code>public class Police implements Watcher
{
     @Override
     public void update()
     {
          System.out.println(“运输车有行动，警察护航");
     }
}  </code></pre>
<pre><code>public class Transporter implements Watched
{
     private List&lt;Watcher&gt; list = new ArrayList&lt;Watcher&gt;();  

     @Override
     public void addWatcher(Watcher watcher)
     {
          list.add(watcher);
     }  

     @Override
     public void removeWatcher(Watcher watcher)
     {
          list.remove(watcher);
     }  

     @Override
     public void notifyWatchers(String str)
     {
          for (Watcher watcher : list)
          {
               watcher.update();
          }
     }  

}  </code></pre>
<pre><code>[java] view plain copy print?在CODE上查看代码片派生到我的代码片
public class Test
{
     public static void main(String[] args)
     {
          Transporter transporter = new Transporter();  

          Police police = new Police();
          Security security = new Security();
          Thief thief = new Thief();  

          transporter.addWatcher(police);
          transporter.addWatcher(security);
          transporter.addWatcher(security);  

          transporter.notifyWatchers();
     }
}  </code></pre>
<p>推模型和拉模型 <br />
在观察者模式中，又分为推模型和拉模型两种方式。 <br />
　　●　　推模型 <br />
　　　　 主题对象向观察者推送主题的详细信息，不管观察者是否需要，推送的信息通常是主题对象的全部或部分数据。 <br />
　　●　　拉模型 <br />
　　　　 主题对象在通知观察者的时候，只传递少量信息。如果观察者需要更具体的信息，由观察者主动到主题对象中获取，相当于是观察者从主题对象中拉数据。一般这种模型的实现中，会把主题对象自身通过update()方法传递给观察者，这样在观察者需要获取数据的时候，就可以通过这个引用来获取了。</p>
<p>最近做一个消息系统，其中涉及到新消息数的即时更新，当时就想到了观察者模式，后来听同事提到推拉模式，感觉推模式原理上应该还是属于观察者模式，只不过把server变成了被观察对象，client被动观察 . <br />
其实推拉模式我们经常遇到，如广播(推)、HTTP请求(拉)，只是没有刻意去追求概念。设计时还是应该多考虑到。 <br />
考虑到性能还效率，最终还是选择了拉模式，每隔一断时间请求一次、更新。</p>
<p>下面是引用:  <br />
推(push)模式是一种基于客户器/服务器机制、由服务器主动将信息送到客户器的技术。在push模式应用中，服务器把信息送给客户器之前，并没有明显的客户请求。push事务由服务器发起。push模式可以让信息主动、快速地寻找用户/客户器，信息的主动性和实时性比较好。但精确性较差，可能推送的信息并不一定满足客户的需求。推送模式不能保证能把信息送到客户器，因为推模式采用了广播机制，如果客户器正好联网并且和服务器在同一个频道上，推送模式才是有效的。push模式无法跟踪状态，采用了开环控制模式，没有用户反馈信息。在实际应用中，由客户器向服务器发送一个申请，并把自己的地址（如IP、port）告知服务器，然后服务器就源源不断地把信息推送到指定地址。在多媒体信息广播中也采用了推模式。另外，如手机<em>*</em>、qq广播。</p>
<p>拉（pull）模式与推模式相反，是由客户器主动发起的事务。服务器把自己所拥有的信息放在指定地址（如IP、port），客户器向指定地址发送请求，把自己需要的资源“拉”回来。不仅可以准确获取自己需要的资源，还可以及时把客户端的状态反馈给服务器。 <br />
使用jdk的java.util.Observable</p>
<pre><code>import java.util.Observable;
/**
 * 天气目标的具体实现类
 * @author lenovo
 *
 */
public class ConcreatWeatherSubject extends Observable{

    private String content;

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
        //通知所有的观察者
        this.setChanged();
        //推模型：主动通知
        this.notifyObservers(content);
        //this.notifyObservers();
    }

}</code></pre>
<pre><code>import java.util.Observable;
import java.util.Observer;

public class ConcreatObserver implements Observer {

    private String observerName;

    public String getObserverName() {
        return observerName;
    }

    public void setObserverName(String observerName) {
        this.observerName = observerName;
    }

    /**
     * Observable o 拉取方式
     * Object arg   推的方式，推具体的内容过来
     */
    @Override
    public void update(Observable o, Object arg) {
        System.out.println(this.observerName+"收到推送消息:"+arg);
        System.out.println(this.observerName+"拉去消息中的内容："+((ConcreatWeatherSubject)o).getContent());
    }
}
</code></pre>
<pre><code>public class Client {
    public static void main(String[] args) {
        ConcreatWeatherSubject subject= new ConcreatWeatherSubject();
        ConcreatObserver girl = new ConcreatObserver();
        girl.setObserverName("king");
        ConcreatObserver girl1 = new ConcreatObserver();
        girl1.setObserverName("jinhang");
        ConcreatObserver girl2 = new ConcreatObserver();
        girl2.setObserverName("kee");
        subject.addObserver(girl1);
        subject.addObserver(girl);
        subject.addObserver(girl2);
        subject.setContent("天气晴朗！");

    }
}
</code></pre>
<p>条件消息系统</p>
<pre><code>import java.util.ArrayList;
import java.util.List;

public abstract class WeatherSubject {

    public List&lt;Observer&gt; observers = new ArrayList&lt;Observer&gt;();

    public void attach(Observer o) {
        observers.add(o);
    }

    public void dettach(Observer o) {
        observers.remove(o);
    }

    protected abstract void notifyObservers();
}
</code></pre>
<pre><code>import java.util.Iterator;

public class Subject1 extends WeatherSubject{

    private String weatherContent;

    public String getWeatherContent() {
        return weatherContent;
    }

    public void setWeatherContent(String weatherContent) {
        this.weatherContent = weatherContent;
        this.notifyObservers();
    }

    @Override
    protected void notifyObservers() {
        for(Observer o: observers){
            //通知条件
            if("下雨".equals(this.weatherContent)){
                System.out.println("notifyObservers");
                if("jinhang".equals(o.getObserverName())){
                    o.update(this);
                }
                if("kee".equals(o.getObserverName())){
                    o.update(this);
                }
            }
            if("下雪".equals(this.weatherContent)){
                if("king".equals(o.getObserverName())){
                    o.update(this);
                }
            }

        }
    }
}</code></pre>
<pre><code>public interface Observer {

    public void update(WeatherSubject subject);
    public void setObserverName(String observerName);
    public String getObserverName();
}
</code></pre>
<pre><code>public class Observer1 implements Observer{

    private  String observerName;
    private  String weatherContent;
    private  String remindContet;
    public String getWeatherContent() {
        return weatherContent;
    }

    public void setWeatherContent(String weatherContent) {
        this.weatherContent = weatherContent;
    }

    public String getRemindContet() {
        return remindContet;
    }

    public void setRemindContet(String remindContet) {
        this.remindContet = remindContet;
    }

    @Override
    public void update(WeatherSubject subject) {
        System.out.println("start...............");
        weatherContent = ((Subject1)subject).getWeatherContent();
        System.out.println(observerName+"收到消息"+weatherContent+"准备去："+remindContet);
    }

    @Override
    public void setObserverName(String observerName) {
        this.observerName = observerName;
    }

    @Override
    public String getObserverName() {
        return observerName;
    }

}</code></pre>
<pre><code>public class Test {
    public static void main(String[] args) {
        Subject1 subject1 = new Subject1();
        Observer1 observer1 = new Observer1();
        Observer1 observer2 = new Observer1();
        observer1.setObserverName("jinhang");
        observer1.setRemindContet("购物");
        observer2.setObserverName("kee");
        observer2.setRemindContet("不出去了");
        subject1.attach(observer1);
        subject1.attach(observer2);
        subject1.setWeatherContent("下雨");
    }
}
</code></pre>
<p>JUnit为用户提供了三种不同的测试结果显示界面，以后还可能会有其它方式的现实界面……。怎么才能将测试的业务逻辑和显示结果的界面很好的分离开？不用问，就是观察者模式！</p>
<pre><code>public interface TestListener {
       /**
       * An error occurred.
       */
       public void addError(Test test, Throwable t);
       /**
       * A failure occurred.
       */
      public void addFailure(Test test, AssertionFailedError t);
       /**
        * A test ended.
        */
      public void endTest(Test test);
       /**
        * A test started.
        */
       public void startTest(Test test);
}</code></pre>
<pre><code>//具体观察者角色，我们采用最简单的TextUI下的情况来说明（AWT，Swing对于整天做Web应用的人来说，已经很陌生了）
public class ResultPrinter implements TestListener {
       //省略好多啊，主要是显示代码
……
       //下面就是实现接口TestListener的四个方法
       //填充方法的行为很简单的说
       /**
        * @see junit.framework.TestListener#addError(Test, Throwable)
        */
       public void addError(Test test, Throwable t) {
              getWriter().print("E");
       }
       /**
        * @see junit.framework.TestListener#addFailure(Test, AssertionFailedError)
        */
       public void addFailure(Test test, AssertionFailedError t) {
              getWriter().print("F");
       }
       /**
        * @see junit.framework.TestListener#endTest(Test)
        */
       public void endTest(Test test) {
       }
       /**
        * @see junit.framework.TestListener#startTest(Test)
        */
       public void startTest(Test test) {
              getWriter().print(".");
              if (fColumn++ &gt;= 40) {
                     getWriter().println();
                     fColumn= 0;
              }
       }
}

来看下我们的目标角色，随便说下，由于JUnit功能的简单，只有一个目标——TestResult，因此JUnit只有一个具体目标角色。
//好长的代码，好像没有重点。去掉了大部分与主题无关的信息
//下面只列出了当Failures发生时是怎么来通知观察者的
public class TestResult extends Object {
       //这个是用来存放测试Failures的集合
protected Vector fFailures;
//这个就是用来存放注册进来的观察者的集合
       protected Vector fListeners;

       public TestResult() {
              fFailures= new Vector();
              fListeners= new Vector();
       }
       /**
        * Adds a failure to the list of failures. The passed in exception
        * caused the failure.
        */
       public synchronized void addFailure(Test test, AssertionFailedError t) {
              fFailures.addElement(new TestFailure(test, t));
              //下面就是通知各个观察者的addFailure方法
              for (Enumeration e= cloneListeners().elements(); e.hasMoreElements(); ) {
                     ((TestListener)e.nextElement()).addFailure(test, t);
              }
       }
       /**
        * 注册一个观察者
        */
       public synchronized void addListener(TestListener listener) {
              fListeners.addElement(listener);
       }
       /**
        * 删除一个观察者
        */
       public synchronized void removeListener(TestListener listener) {
              fListeners.removeElement(listener);
       }
       /**
        * 返回一个观察者集合的拷贝，当然是为了防止对观察者集合的非法方式操作了
     * 可以看到所有使用观察者集合的地方都通过它
        */
       private synchronized Vector cloneListeners() {
              return (Vector)fListeners.clone();
       }
       ……
}
</code></pre>
<pre><code>察者模式组成所需要的角色在这里已经全了。不过好像还是缺点什么……。呵呵，对！就是它们之间还没有真正的建立联系。在JUnit中是通过TestRunner来作的，而你在具体的系统中可以灵活掌握。
看一下TestRunner中的代码：
public class TestRunner extends BaseTestRunner {
       private ResultPrinter fPrinter;
public TestResult doRun(Test suite, boolean wait) {
//就是在这里注册的
              result.addListener(fPrinter);</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 14:42:31</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/update/" title="update">update</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/test/" title="test">test</a>, <a href="https://www.iamivan.net/tag/watcher/" title="watcher">watcher</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>java-设计模式-观察者模式的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOm0x5M.html" rel="bookmark">Java设计模式----观察者模式详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[正文] 一.观察者模式的定义: 简单地说,观察者模式定义了一个一对多的依赖关系,让一个或多个观察者对象监听一个主题对象.这样一来,当被观察者状态发生改变时,需要通知相应的观察者,使这些观察者对象能够自动更新.例如:GUI中的事件处理机制采用的就是观察者模式.   二.观察者模式的实现: Subject(被观察的对象接口):规定ConcreteSubject的统一接口 ; 每个Subject可以有多个Observer: ConcreteSubject(具体被观察对象):维护对所有具体观察者的引用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvqm3Wb.html" rel="bookmark">Java设计模式--观察者模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				观察者模式(别名:依赖,发布-订阅) 定义对象间的一种一对多的依赖关系,当一个对象的状态发生变化时,所有依赖它的对象都得到通知并被自动更新. Observer Pattern(Another Name: Dependents, Publish-Subscribe) Define a one-to-many dependency between objects so that when one object changes state, all its dependents are notifie			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOl3mxb.html" rel="bookmark">Java设计模式开发中使用观察者模式的实例教程&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				观察者模式是软件设计模式中的一种,使用也比较普遍,尤其是在GUI编程中.关于设计模式的文章,网络上写的都比较多,而且很多文章写的也不错,虽然说有一种重复早轮子的嫌疑,但此轮子非彼轮子,侧重点不同,思路也不同,讲述方式也不近相同.关键要素 主题: 主题是观察者观察的对象,一个主题必须具备下面三个特征. 持有监听的观察者的引用 支持增加和删除观察者 主题状态改变,通知观察者 观察者: 当主题发生变化,收到通知进行具体的处理是观察者必须具备的特征. 为什么要用这种模式 这里举一个例子来说明,牛奶送奶站			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn8Z02b.html" rel="bookmark">实例解析观察者模式及其在Java设计模式开发中的运用&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.观察者模式(Observer)的定义: 观察者模式又称为订阅-发布模式,在此模式中,一个目标对象管理所有相依于它的观察者对象,并且在它本身的状态改变时主动发出通知.这通常透过呼叫各观察者所提供的方法来实现.此种模式通常被用来事件处理系统. 1.观察者模式的一般结构 首先看下观察者模式的类图描述: 观察者模式的角色如下: Subject(抽象主题接口):定义了主题类中对观察者列表的一系列操作, 包括增加,删除, 通知等. Concrete Subject(具体主题类): Observer(抽象			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk0vLwz.html" rel="bookmark">深入解析Java设计模式编程中观察者模式的运用&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				定义:定义对象间一种一对多的依赖关系,使得当每一个对象改变状态,则所有依赖于它的对象都会得到通知并自动更新.类型:行为类模式类图: 在软件系统中经常会有这样的需求:如果一个对象的状态发生改变,某些与它相关的对象也要随之做出相应的变化.比如,我们要设计一个右键菜单的功能,只要在软件的有效区域内点击鼠标右键,就会弹出一个菜单:再比如,我们要设计一个自动部署的功能,就像eclipse开发时,只要修改了文件,eclipse就会自动将修改的文件部署到服务器中.这两个功能有一个相似的地方,那就是一个对象要时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNDL5p.html" rel="bookmark">用Java设计模式中的观察者模式开发微信公众号的例子&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				还记得警匪片上,匪徒们是怎么配合实施犯罪的吗?一个团伙在进行盗窃的时候,总有一两个人在门口把风--如果有什么风吹草动,则会立即通知里面的同伙紧急撤退.也许放风的人并不一定认识里面的每一个同伙:而在里面也许有新来的小弟不认识这个放风的.但是这没什么,这个影响不了他们之间的通讯,因为他们之间有早已商定好的暗号. 呵呵,上面提到的放风者.偷窃者之间的关系就是观察者模式在现实中的活生生的例子. 观察者(Observer)模式又名发布-订阅(Publish/Subscribe)模式.GOF给观察者模式如下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9jPVXp.html" rel="bookmark">学习Java设计模式之观察者模式&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				观察者模式:对象间的一种一对多的依赖关系,让多个观察者对象同时监听某一个主题对象(被观察). 以便一个对象的状态发生变化时,所有依赖于它的对象都得到通知并发生相应的变化. 观察者模式有很多实现方式:该模式必须包含观察者和被观察对象两种角色.观察者和被观察者之间存在&quot;观察&quot;的逻辑关系,当被观察者发生改变的时候,观察者就会观察到这样的变化,发出相应的改变. /** * 观察者接口:观察者,需要用到观察者模式的类需实现此接口 */ public interface Observer { pu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDJ160M.html" rel="bookmark">java设计模式之观察者模式&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        观察者模式又称发布-订阅(Publish/Subscribe)模式,定义了一种一对多的依赖关系,让多个观察者对象同时监听某一个主题对象.这个主题对象在状态发生变化时,会通知所有观察者对象,使他们能够自动更新自己.将一个系统分割成一系列相互协作的类有一个很不好的副作用,那就是需要维护相关对象间的一致性.我们不希望为了维持一致性而使各类紧密耦合,这样会给维护.扩展和复用都带来不便.观察者模式所做的工作其实就是在解除耦合,让耦合的双方都依赖于抽象,而不是依赖于具体. 观察者模式是实际中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQ6Znp.html" rel="bookmark">Java设计模式（十五）----观察者模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				观察者模式 一.定义 二.结构 具体案例 推模型和拉模型 三.Java提供的对观察者模式的支持 Observer接口 Observable类 一.定义 观察者模式是对象的行为模式,又叫发布-订阅(Publish/Subscribe)模式.模型-视图(Model/View)模式.源-监听器(Source/Listener)模式或从属者(Dependents)模式. 观察者模式定义了一种一对多的依赖关系,让多个观察者对象同时监听某一个主题对象.这个主题对象在状态上发生变化时,会通知所有观察者对象,使			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/6b3Namz.html" rel="bookmark">您的设计模式，我们的设计模式 java设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://download.csdn.net/download/yangxin00000000/3212729   您的设计模式,我们的设计模式 java设计模式			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bojLDz.html" rel="bookmark" class="title">Firefox下的window&period;event问题</a>
					<div>
						如何解决firefox下window.event的问题,如下代码:     &lt;body&gt;       &lt;script&gt;       function mouseMove(ev) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlJaNz.html" rel="bookmark" class="title">C&plus;&plus;和c语言里面的const有什么区别</a>
					<div>
						众所周知:在C语言里面用const:是可以修改的: //C语言里面可以通过指针修改 int main() { //可以这么说在C语言中a是一个只读的常量.按照理论我们不好修改// const int  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jRXVb.html" rel="bookmark" class="title">Direct3D9初级教程</a>
					<div>
						前言: 这篇教程是为初学者准备的,只要会简单的VC++编程以及一点立体几何的基础知识即可.通过它,可以了解到Direct3D的基本概念,学会绘制简单的几何图形,并掌握光源.材质和纹理的基本用法. 3D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bal4qmz.html" rel="bookmark" class="title">MySQL中字符串函数详解</a>
					<div>
						字符串或串(String)是由零个或多个字符组成的有限序列.一般记为 s='a1a2•••an'(n&gt;=0).它是编程语言中表示文本的数据类型. 通常以串的整体作为操作对象,如:在串中查找某个子 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyE3kb.html" rel="bookmark" class="title">js动态给table添加&sol;删除tr的方法</a>
					<div>
						这篇文章介绍了js动态给table添加/删除tr的方法,有需要的朋友可以参考一下   复制代码 代码如下:  &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oOLBb.html" rel="bookmark" class="title">用PS设计一枚IOS 7风格日记图标</a>
					<div>
						  扁平化风格潮流浩浩荡荡,童鞋们周末有时间也来撸一发,学习一下扁平化风格icon的设计思路吧.今天分享的教程是教你创建一枚IOS 7 风格的图标,教程不难,熟练的童鞋30分钟就可以完成咯.好嘞,教程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGDD5b.html" rel="bookmark" class="title">IE图标被删了怎么办</a>
					<div>
						  第一种方法,IE浏览器一般都默认安装在C盘,Program Files文件夹里面的Internet Explorer 文件夹里面,打开这个文件夹,可以看到IE浏览器,右键单机浏览器,选择发送到-- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkDkWb.html" rel="bookmark" class="title">苹果 ：云计算 真的很可怕</a>
					<div>
						据国外媒体报道,苹果联合创始人史蒂夫-沃兹尼亚克(Steve Wozniak)预测,在未来几年中,云计算服务将会出现&quot;可怕的问题&quot;. 在表演者迈克-戴西(Mike Daisey)的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjDO4b.html" rel="bookmark" class="title">微信开发 网页授权获取用户基本信息</a>
					<div>
						微信公众平台最近新推出微信认证,认证后可以获得高级接口权限,其中一个是OAuth2.0网页授权,很多朋友在使用这个的时候失败了或者无法理解其内容,希望我出个教程详细讲解一下,于是便有了这篇文章. 一. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4Ny2PM.html" rel="bookmark" class="title">详解jQuery移动页面开发中的ui-grid网格布局使用&lowbar;jquery</a>
					<div>
						在移动设备上,屏幕宽度狭窄,因此通常不使用多栏布局,但是有时你可能需要将小的元素(如按钮或并排导航标签,例如)多列排列在一起.Jquery Mobile 框架提供了一种简单的方法构建基于css 的分栏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamdoPb.html" rel="bookmark" class="title">解密：Python风靡全宇宙，首要原因竟是它？</a>
					<div>
						众所周知,Python是目前使用最广泛且用户增长最快的编程语言.优雅简洁的语法.强大的第三方库支持等都是Python能够风靡各行各业的原因.然而,你或许不知道,Python能够实现用户飞速增长,背后其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lj88b.html" rel="bookmark" class="title">关于睡眠健康那些事</a>
					<div>
						睡觉的诀窍  根据医学和我的体验.观察,一个人真正睡着觉最多只有两个钟头,其余都是浪费时间,躺在枕头上做梦,没有哪个人不做梦.至于醒来觉得自己没有做梦,那是因为他忘记了.  通常一个人睡两个钟头就够了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32OyNz.html" rel="bookmark" class="title">撩妹神器，打造圣诞雪花特效附加线上热修复</a>
					<div>
						相信去年圣诞节打开过手机淘宝的童鞋都会对当时的特效记忆犹新吧:全屏飘雪,旁边还有个小雪人来控制八音盒背景音乐的播放,让人有种身临其境的感觉,甚至忍不住想狠狠购物了呢(误),大概就是下面这个样子滴: 嗯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKx6rz.html" rel="bookmark" class="title">HQL 问题   帮忙解释一下</a>
					<div>
						问题描述 //查找用户拥有的角色,并按优先级从低到高排序 &quot;select r.id from UsersRoles ur join ur.role r join ur.user u &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqqyQz.html" rel="bookmark" class="title">javvweb  连接数据库出现问题  求大神指教</a>
					<div>
						问题描述 javvweb 连接数据库出现问题 求大神指教 下面是程序代码 &lt;%@ page language=&quot;java&quot; import=&quot;java.util.*, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rWvAz.html" rel="bookmark" class="title">c&num;-C&num;其他信息&colon; 索引超出了数组界限。</a>
					<div>
						问题描述 C#其他信息: 索引超出了数组界限. private void button1_Click(object sender, EventArgs e) { string str = richTe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRGmwb.html" rel="bookmark" class="title">联网时代带来不仅仅是技术上的革命</a>
					<div>
						联网时代带来不仅仅是技术上的革命,给我们的日常生活也带来实实在在的改变.理论上,来自全世界的消息,新闻以及评论我们都可以通过点击鼠标轻松浏览.但是如果要准确的找到所要的东西并非易事.学会充分利用搜索网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYnmAp.html" rel="bookmark" class="title">搜索引擎需要了解用户的真正需求是什么</a>
					<div>
						摘要: 搜索引擎的三个核心问题与网站的用户体验优化相关联,搜索引擎需要去了解用户的需求,而我们需要去了解搜索引擎的判断,以及给出搜索引擎更直接的反应我们产品或是帮助用户的 搜索引擎的三个核心问题与网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB6GgM.html" rel="bookmark" class="title">java实现图片和字符串互相转换的代码</a>
					<div>
						  java实现图片和字符串互相转换的代码,也就是说java 转换图片为字符串,将字符串转换成图片显示,具体如下: java 转换图片为字符串,网页代理将字符串转换成图片显示, nod32 用户名和密 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjYAOM.html" rel="bookmark" class="title">CentOS 5&period;9下安装配置keepalived</a>
					<div>
						    keepalived是由C语言编写的路由软件,是lvs的扩展项目,主要用作RealServer的健康状态检查以及LoadBalance主机和BackUP主机之间failover的实现.keep ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrql8xb.html" rel="bookmark" class="title">关于URI的问题</a>
					<div>
						问题描述 高手们,请问一下为什么主机名有下划线会出现这个现象public static void main(String[] args) { URI uri = new URI(&quot;http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgej5M.html" rel="bookmark" class="title">有没有对rundeck软件有所了解的？</a>
					<div>
						问题描述 如题,rundeck是一款开源的自动发布工具,目前已从官网下载了部分源代码,但是找不到开发环境intelliJeclipsenetbeans都试过但是根据代码都无法启动项目不知道哪里配置的有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodvYXM.html" rel="bookmark" class="title">javascript- jquery赋值&amp;amp&semi;amp&semi;lt&semi;id&equals;&amp;amp&semi;amp&semi;quot&semi;process&lowbar;in&lowbar;desc&lowbar;&commat;a&amp;amp&semi;amp&semi;quot&semi; type&equals;&amp;amp&semi;amp&semi;quot&semi;text&amp;amp&semi;amp&semi;quot&semi;&amp;amp&semi;amp&semi;gt&semi;</a>
					<div>
						问题描述 jquery赋值&lt;id=&quot;process_in_desc_@a&quot; type=&quot;text&quot;&gt; &lt;input name=&quot;pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg930M.html" rel="bookmark" class="title">服务器-socket通讯方面的问题</a>
					<div>
						问题描述 socket通讯方面的问题 Android用socket实现仿QQ功能时,必须要有文件服务器么?服务器用多个端口监听不行么? 还有socket只能同时发送一条信息么?可不可以用线程同时发送多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RGORz.html" rel="bookmark" class="title">Windows8&period;1微软能否拯救微软呢</a>
					<div>
						微软公司(Microsoft)将于10月18日在美国发布Windows 8.1.这一该公司的旗舰操作系统的免费更新版本旨在安抚大量的对新操作平台表示不满的用户们. 然而,尽管微软公司正在对其最新版本的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKN5vM.html" rel="bookmark" class="title">mcrypt启用 加密以及解密过程详细解析&lowbar;php技巧</a>
					<div>
						Mcrypt扩展库可以实现加密解密功能,就是既能将明文加密,也可以密文还原. 1.PHP加密扩展库Mcrypt安装在标准的PHP安装过程中并没有把Mrcypt安装上,但PHP的主目录下包含了libmc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxENWmp.html" rel="bookmark" class="title">JavaScript类和继承 prototype属性&lowbar;js面向对象</a>
					<div>
						我们已经在第一章中使用prototype属性模拟类和继承的实现. prototype属性本质上还是一个JavaScript对象. 并且每个函数都有一个默认的prototype属性. 如果这个函数被用在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL1XvM.html" rel="bookmark" class="title">无法返回当前登录用户信息&period;</a>
					<div>
						问题描述 我用了以下4种方式返回当前登录的用户名,在VS2005环境中点击右键用IE浏览都能成功,但在iis服务下,却返回NETWORKSERVICE的信息,请问各位高手,iis是否要单独配置,请指出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByKKAz.html" rel="bookmark" class="title">音著协起诉歌词搜索侵权案宣判百度被罚5万元</a>
					<div>
						本报讯 (记者 李宽宽)昨日,百度证实,中国音乐著作权协会(简称音著协)起诉百度MP3歌词搜索侵权一案当日已在北京海淀法院一审宣判,百度败诉.根据法院判决,百度停止通过快照等形式提供相关50首歌的歌词 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvmg3b.html" rel="bookmark" class="title">宏基推迟Windows RT平板电脑上市时间</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   [科技讯]10月31日消息,宏碁推迟Widnows R ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
